using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace ITCWebshop4.Models.Mapping
{
    public class tblProductMap : EntityTypeConfiguration<tblProduct>
    {
        public tblProductMap()
        {
            // Primary Key
            this.HasKey(t => t.ProductId);

            // Properties
            this.Property(t => t.ShortDescr)
                .IsRequired()
                .HasMaxLength(100);

            this.Property(t => t.LongDescr)
                .IsRequired()
                .HasMaxLength(2000);

            this.Property(t => t.ShippingTerms)
                .IsRequired()
                .HasMaxLength(200);

            this.Property(t => t.StateChangeBy)
                .HasMaxLength(50);

            this.Property(t => t.CreatedBy)
                .IsRequired()
                .HasMaxLength(50);

            this.Property(t => t.ChangedBy)
                .HasMaxLength(50);

            // Table & Column Mappings
            this.ToTable("tblProducts");
            this.Property(t => t.ProductId).HasColumnName("ProductId");
            this.Property(t => t.VendorUserId).HasColumnName("VendorUserId");
            this.Property(t => t.ProductNo).HasColumnName("ProductNo");
            this.Property(t => t.ShortDescr).HasColumnName("ShortDescr");
            this.Property(t => t.LongDescr).HasColumnName("LongDescr");
            this.Property(t => t.CategorieId).HasColumnName("CategorieId");
            this.Property(t => t.Price).HasColumnName("Price");
            this.Property(t => t.ShippingTerms).HasColumnName("ShippingTerms");
            this.Property(t => t.ShippingCost).HasColumnName("ShippingCost");
            this.Property(t => t.State).HasColumnName("State");
            this.Property(t => t.StateChangeBy).HasColumnName("StateChangeBy");
            this.Property(t => t.StateChangedAt).HasColumnName("StateChangedAt");
            this.Property(t => t.CreatedAt).HasColumnName("CreatedAt");
            this.Property(t => t.CreatedBy).HasColumnName("CreatedBy");
            this.Property(t => t.ChangedAt).HasColumnName("ChangedAt");
            this.Property(t => t.ChangedBy).HasColumnName("ChangedBy");

            // Relationships
            this.HasRequired(t => t.tblCategorie)
                .WithMany(t => t.tblProducts)
                .HasForeignKey(d => d.CategorieId);
            this.HasRequired(t => t.tblUser)
                .WithMany(t => t.tblProducts)
                .HasForeignKey(d => d.VendorUserId);

        }
    }
}
